<template>
  <ValidationObserver v-slot="{ handleSubmit }">
    <CForm
      v-loading="loading"
      class="user-form"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardBody>
          <div class="box-inner-form">
            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.name"
                    label="Thing name"
                    horizontal
                    placeholder="Enter Thing name"
                    type="text"
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'lightbulb']" class="width-1x" />
                    </template>

                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <CInput
                  v-model="model.description"
                  label="Description"
                  placeholder="Enter short description"
                  horizontal
                  type="text"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'bars']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required|regx">
                  <div role="group" class="form-group form-row">
                    <CCol tag="label" sm="3" class="col-form-label">
                      Mac Address
                    </CCol>

                    <CCol sm="9" class="form-inline input-group">
                      <div class="input-group-prepend">
                        <span class="input-group-text">
                          <font-awesome-icon :icon="['fas', 'grip-vertical']" class="width-1x" />
                        </span>
                      </div>

                      <masked-input
                        v-model="model.macAddress"
                        :mask="MAC"
                        type="text"
                        name="macadress"
                        class="form-control"
                        placeholder="xx : xx : xx : xx : xx : xx"
                      />
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </CCol>
                  </div>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required|regx">
                  <div role="group" class="form-group form-row">
                    <CCol tag="label" sm="3" class="col-form-label">
                      IPv4 Address
                    </CCol>

                    <CCol sm="9" class="form-inline input-group">
                      <div class="input-group-prepend">
                        <span class="input-group-text">
                          <font-awesome-icon :icon="['fas', 'code']" class="width-1x" />
                        </span>
                      </div>

                      <masked-input
                        v-model="model.ipAddress"
                        :mask="IP"
                        type="text"
                        name="ipaddress"
                        class="form-control"
                        placeholder="xxx . xxx . xxx . xxx "
                      />
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </CCol>
                  </div>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required|minValue:-90|maxValue:90|float:2">
                  <CInput
                    v-model="model.latitude"
                    label="Latitude"
                    type="number"
                    min="-90"
                    max="90"
                    step=".01"
                    placeholder="0.00"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'map-marker-alt']" class="width-1x" />
                    </template>

                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required|minValue:-90|maxValue:90|float:2">
                  <CInput
                    v-model="model.longitude"
                    label="Longitude"
                    type="number"
                    min="-180"
                    max="180"
                    step=".01"
                    placeholder="0.00"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'map-marker-alt']" class="width-1x" />
                    </template>

                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <CSelect
                  v-model="model.groupId"
                  label="Select Groups"
                  horizontal
                  :options="OPTIONS"
                  placeholder="Please select"
                  :value.sync="model.groupId"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'sitemap']" class="width-1x" />
                  </template>
                </CSelect>
              </div>

              <div class="col-12 col-lg-6">
                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Status
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <app-radio-group v-model="model.status" :list="[]" :name="'status'" />
                  </CCol>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6">
                <!-- Slider begin -->
                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Color Red
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <AppSlider
                      v-model="model.color_r"
                      :min-val="minVal"
                      :max-val="maxVal"
                      :color-slider="redSlider"
                    />
                  </CCol>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Color Green
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <AppSlider
                      v-model="model.color_g"
                      :min-val="minVal"
                      :max-val="maxVal"
                      :color-slider="greenSlider"
                    />
                  </CCol>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Color Blue
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <AppSlider
                      v-model="model.color_b"
                      :min-val="minVal"
                      :max-val="maxVal"
                      :color-slider="blueSlider"
                    />
                  </CCol>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9" class="form-inline">
                    <div :style="{backgroundColor: `rgb(${model.color_r}, ${model.color_g}, ${model.color_b}`}" class="resultColors">
                      <strong>rgb({{ model.color_r }}, {{ model.color_g }}, {{ model.color_b }})</strong>
                    </div>
                  </CCol>
                </div>
              <!-- Slider end -->
              </div>

              <div class="col-12 col-lg-6">
                <CTextarea
                  v-model="model.attribute"
                  label="Attribute"
                  placeholder="Content..."
                  horizontal
                  rows="9"
                />
              </div>
            </div>
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            Save
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('close')"
          >
            Cancel
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<style lang="scss">
  .resultColors {
    display: flex;
    width: 100%;
    height: 45px;
    justify-content: center;
    align-items: center;
    border: 1px solid;
  }
</style>

<script>
import { get } from 'lodash'
import AppSlider from '~/components/atoms/AppSlider'
import AppRadioGroup from '~/components/atoms/AppRadioGroup'

import Thing from '~/models/Thing'

import createEditForm from '~/mixins/create-edit-form'

const MAC = [/[0-9a-fA-F]/, /[0-9a-fA-F]/, ':', /[0-9a-fA-F]/, /[0-9a-fA-F]/, ':', /[0-9a-fA-F]/, /[0-9a-fA-F]/, ':', /[0-9a-fA-F]/, /[0-9a-fA-F]/, ':', /[0-9a-fA-F]/, /[0-9a-fA-F]/, ':', /[0-9a-fA-F]/, /[0-9a-fA-F]/]
const IP = [/[0-9]/, /[0-9]/, /[0-9]/, '.', /[0-9]/, /[0-9]/, /[0-9]/, '.', /[0-9]/, /[0-9]/, /[0-9]/, '.', /[0-9]/, /[0-9]/, /[0-9]/]

export default {
  components: {
    AppSlider,
    AppRadioGroup
  },

  mixins: [createEditForm],

  data () {
    return {
      minVal: 0,
      maxVal: 255,
      blueSlider: 'blue-slider',
      redSlider: 'red-slider',
      greenSlider: 'green-slider',
      model: new Thing(),
      modelType: 'thing',
      data: []
    }
  },

  computed: {
    /**
     * Return list group item options
     *
     */
    OPTIONS () {
      const options = []
      this.data.forEach((item) => {
        const param = { value: item.id, label: item.name }
        options.push(param)
      })
      return options
    },

    /**
     * Return mask input MAC address
     *
     */
    MAC () {
      return MAC
    },

    /**
     * Return mask input IP address
     *
     */
    IP () {
      return IP
    }
  },

  methods: {
    /**
     * Return current value colors
     *
     * @param {Number, String} - Get value R-G-B and string colors
     */
    getValue (val, colors) {
      if (colors === this.redSlider) {
        this.color_r = parseInt(val)
      }
      if (colors === this.blueSlider) {
        this.color_b = parseInt(val)
      }
      if (colors === this.greenSlider) {
        this.color_g = parseInt(val)
      }
    },

    /**
     * Dynamic set model
     * @param {Object} data
     */
    setModel (data) {
      this.model = new Thing(data)
    },

    /**
     * Prepare data
     *
     */
    prepareData () {
      this.$dam.getGroupList()
        .then((res) => {
          this.data = res.data
        })
        .catch((err) => {
          const message = get(err, 'response.data.message', null)
          if (message) {
            this.$toast.error(message)
          } else {
            this.$toast.error(
              this.$text.error('FAILED_TO_DATA')
            )
          }
        })
    }
  }
}
</script>
